#include <NewPing.h>

#define TRIGGER_PIN  2  // Arduino pin tied to trigger pin on the ultrasonic sensor.
#define ECHO_PIN     3  // Arduino pin tied to echo pin on the ultrasonic sensor.
#define MAX_DISTANCE 200 // Maximum distance we want to ping for (in centimeters). Maximum sensor distance is rated at 400-500cm.

NewPing sonar(TRIGGER_PIN, ECHO_PIN, MAX_DISTANCE); 


#define TRIGGER_PIN_1  12  // Arduino pin tied to trigger pin on the ultrasonic sensor.
#define ECHO_PIN_1     11  // Arduino pin tied to echo pin on the ultrasonic sensor.
#define MAX_DISTANCE_1 200 // Maximum distance we want to ping for (in centimeters). Maximum sensor distance is rated at 400-500cm.

NewPing sonar_1(TRIGGER_PIN_1, ECHO_PIN_1, MAX_DISTANCE_1); 

int lm=76; //Left motor speed 
int rm=93; //Right motor speed

void setup() {
  Serial.begin(9600); 
  pinMode(5,OUTPUT);
  pinMode(6,OUTPUT);
  pinMode(7,OUTPUT);
  pinMode(8,OUTPUT);
  pinMode(9,OUTPUT);
  pinMode(10,OUTPUT);
  forward();
  delay(1500);
}

void loop() {
                       
  Serial.print("Ping: ");
  Serial.print(sonar.ping_cm()); // Send ping, get distance in cm and print result (0 = outside set distance range)
  Serial.println("cm");

 int dist=sonar_1.ping_cm();

  if ((dist>=50)&&(dist!=0))
{
  delay(110);
  stops();
  delay(500);
  left_turn();
  delay(430);
  stops();
  delay(500);
  forward();
  delay(2000);
    }
  
  
  if((sonar.ping_cm()>=18)&&(sonar.ping_cm()<=29))
 {
  forward();
  }
  
 
   if ((sonar.ping_cm()<17)&&(sonar.ping_cm()!=0))
  {
  left();
  }

   if ((sonar.ping_cm()>29)&&(sonar.ping_cm()!=0))
  {
  right();
  }


   if ((sonar.ping_cm()<15)&&(sonar.ping_cm()!=0))
  {
  left_sharp();
  }

  if ((sonar.ping_cm()>35)&&(sonar.ping_cm()!=0))
  {
  right_sharp();
  }

  
}

void forward()
{
   analogWrite(5,rm);
   analogWrite(10,lm);
   digitalWrite(6,HIGH);
   digitalWrite(7,LOW);
   digitalWrite(8,HIGH);
   digitalWrite(9,LOW);
   }

void right()
{
   analogWrite(5,rm);
   analogWrite(10,lm+7);
   digitalWrite(6,HIGH);
   digitalWrite(7,LOW);
   digitalWrite(8,HIGH);
   digitalWrite(9,LOW);
   } 
void left()
{
   analogWrite(5,rm+9);
   analogWrite(10,lm);
   digitalWrite(6,HIGH);
   digitalWrite(7,LOW);
   digitalWrite(8,HIGH);
   digitalWrite(9,LOW);
   }


void left_turn()
{
   analogWrite(5,rm);
   analogWrite(10,84);
   digitalWrite(6,HIGH);
   digitalWrite(7,LOW);
   digitalWrite(8,LOW);
   digitalWrite(9,HIGH);
   }
     

void stops()

{
   analogWrite(5,0);
   analogWrite(10,0);
   digitalWrite(6,HIGH);
   digitalWrite(7,HIGH);
   digitalWrite(8,HIGH);
   digitalWrite(9,HIGH);
 }


void left_sharp()                            
{
   analogWrite(5,rm+18);
   analogWrite(10,lm);
   digitalWrite(6,HIGH);
   digitalWrite(7,LOW);
   digitalWrite(8,HIGH);
   digitalWrite(9,LOW);
}

void right_sharp()
{
  analogWrite(5,rm);
   analogWrite(10,lm+17);
   digitalWrite(6,HIGH);
   digitalWrite(7,LOW);
   digitalWrite(8,HIGH);
   digitalWrite(9,LOW);
}

